
#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 11 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.rl"



#line 13 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.c"
static const char _is_boolean_key_offsets[] = {
	0, 0, 4, 6, 8, 10, 12, 14, 
	16
};

static const char _is_boolean_trans_keys[] = {
	70, 84, 102, 116, 65, 97, 76, 108, 
	83, 115, 69, 101, 82, 114, 85, 117, 
	0
};

static const char _is_boolean_single_lengths[] = {
	0, 4, 2, 2, 2, 2, 2, 2, 
	0
};

static const char _is_boolean_range_lengths[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0
};

static const char _is_boolean_index_offsets[] = {
	0, 0, 5, 8, 11, 14, 17, 20, 
	23
};

static const char _is_boolean_trans_targs[] = {
	2, 6, 2, 6, 0, 3, 3, 0, 
	4, 4, 0, 5, 5, 0, 8, 8, 
	0, 7, 7, 0, 5, 5, 0, 0, 
	0
};

static const int is_boolean_start = 1;
static const int is_boolean_first_final = 8;
static const int is_boolean_error = 0;

static const int is_boolean_en_main = 1;


#line 14 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.rl"

bool is_boolean(const char *const in, const size_t len)
{
    const char *p = in;
    const char *const pe = in + len;
    int cs;

    
#line 63 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.c"
	{
	cs = is_boolean_start;
	}

#line 68 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _is_boolean_trans_keys + _is_boolean_key_offsets[cs];
	_trans = _is_boolean_index_offsets[cs];

	_klen = _is_boolean_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _is_boolean_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _is_boolean_trans_targs[_trans];

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 24 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/boolean.rl"


    return cs != is_boolean_error;
}
