
#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 67 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.rl"



#line 13 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.c"
static const unsigned char _is_dn_key_offsets[] = {
	0, 0, 1, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 42, 56, 62, 69, 
	72, 80, 86, 92, 96, 103, 126, 148
};

static const char _is_dn_trans_keys[] = {
	46, 48, 49, 57, 46, 61, -128, -65, 
	-96, -65, -128, -65, -128, -97, -112, -65, 
	-128, -65, -128, -113, -32, -19, -16, -12, 
	32, 34, 62, 92, -128, -63, -62, -33, 
	-31, -17, -15, -13, -11, 0, 43, 44, 
	59, 60, 32, 92, 34, 35, 43, 44, 
	48, 57, 59, 62, 65, 70, 97, 102, 
	48, 57, 65, 70, 97, 102, 48, 49, 
	57, 65, 90, 97, 122, 46, 48, 57, 
	45, 61, 48, 57, 65, 90, 97, 122, 
	48, 57, 65, 70, 97, 102, 48, 57, 
	65, 70, 97, 102, 46, 61, 48, 57, 
	48, 49, 57, 65, 90, 97, 122, -32, 
	-19, -16, -12, 32, 34, 35, 62, 92, 
	-128, -63, -62, -33, -31, -17, -15, -13, 
	-11, 0, 43, 44, 59, 60, -32, -19, 
	-16, -12, 32, 34, 62, 92, -128, -63, 
	-62, -33, -31, -17, -15, -13, -11, 0, 
	43, 44, 59, 60, 43, 44, 48, 57, 
	65, 70, 97, 102, 0
};

static const char _is_dn_single_lengths[] = {
	0, 1, 1, 2, 0, 0, 0, 0, 
	0, 0, 0, 8, 2, 0, 1, 1, 
	2, 0, 0, 2, 1, 9, 8, 0
};

static const char _is_dn_range_lengths[] = {
	0, 0, 1, 0, 1, 1, 1, 1, 
	1, 1, 1, 7, 6, 3, 3, 1, 
	3, 3, 3, 1, 3, 7, 7, 4
};

static const unsigned char _is_dn_index_offsets[] = {
	0, 0, 2, 5, 8, 10, 12, 14, 
	16, 18, 20, 22, 38, 47, 51, 56, 
	59, 65, 69, 73, 77, 82, 99, 115
};

static const char _is_dn_trans_targs[] = {
	2, 0, 3, 19, 0, 2, 21, 0, 
	22, 0, 4, 0, 4, 0, 4, 0, 
	6, 0, 6, 0, 6, 0, 5, 7, 
	8, 10, 11, 0, 0, 12, 0, 4, 
	6, 9, 0, 0, 0, 22, 22, 22, 
	22, 22, 13, 22, 13, 13, 0, 22, 
	22, 22, 0, 1, 15, 16, 16, 0, 
	2, 15, 0, 16, 21, 16, 16, 16, 
	0, 18, 18, 18, 0, 23, 23, 23, 
	0, 2, 21, 19, 0, 1, 15, 16, 
	16, 0, 5, 7, 8, 10, 0, 0, 
	17, 0, 12, 0, 4, 6, 9, 0, 
	14, 0, 22, 5, 7, 8, 10, 11, 
	0, 0, 12, 0, 4, 6, 9, 0, 
	14, 0, 22, 14, 18, 18, 18, 0, 
	0
};

static const int is_dn_start = 20;
static const int is_dn_first_final = 20;
static const int is_dn_error = 0;

static const int is_dn_en_main = 20;


#line 70 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.rl"

bool is_dn(const char *const in, const size_t len)
{
    const char *p = in;
    const char *const pe = in + len;
    int cs;

    
#line 96 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.c"
	{
	cs = is_dn_start;
	}

#line 101 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _is_dn_trans_keys + _is_dn_key_offsets[cs];
	_trans = _is_dn_index_offsets[cs];

	_klen = _is_dn_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _is_dn_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _is_dn_trans_targs[_trans];

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 80 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/dn.rl"


    return cs != is_dn_error;
}
