
#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 27 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.rl"



#line 13 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.c"
static const char _is_generalized_time_key_offsets[] = {
	0, 0, 2, 4, 6, 8, 10, 12, 
	16, 18, 21, 23, 30, 33, 35, 37, 
	39, 41, 46, 48, 56, 58, 63, 64, 
	66, 68, 70, 72, 74
};

static const char _is_generalized_time_trans_keys[] = {
	48, 57, 48, 57, 48, 57, 48, 57, 
	48, 49, 49, 57, 48, 51, 49, 50, 
	49, 57, 50, 48, 49, 48, 57, 44, 
	46, 90, 43, 45, 48, 53, 50, 48, 
	49, 48, 57, 48, 57, 48, 51, 48, 
	57, 43, 45, 90, 48, 57, 48, 57, 
	44, 46, 54, 90, 43, 45, 48, 53, 
	48, 57, 44, 46, 90, 43, 45, 48, 
	48, 51, 48, 57, 48, 49, 48, 50, 
	48, 53, 0
};

static const char _is_generalized_time_single_lengths[] = {
	0, 0, 0, 0, 0, 2, 0, 2, 
	0, 1, 0, 3, 1, 0, 0, 0, 
	0, 3, 0, 4, 0, 3, 1, 0, 
	0, 0, 0, 0, 0
};

static const char _is_generalized_time_range_lengths[] = {
	0, 1, 1, 1, 1, 0, 1, 1, 
	1, 1, 1, 2, 1, 1, 1, 1, 
	1, 1, 1, 2, 1, 1, 0, 1, 
	1, 1, 1, 1, 0
};

static const char _is_generalized_time_index_offsets[] = {
	0, 0, 2, 4, 6, 8, 11, 13, 
	17, 19, 22, 24, 30, 33, 35, 37, 
	39, 41, 46, 48, 55, 57, 62, 64, 
	66, 68, 70, 72, 74
};

static const char _is_generalized_time_trans_targs[] = {
	2, 0, 3, 0, 4, 0, 5, 0, 
	6, 26, 0, 7, 0, 8, 25, 24, 
	0, 9, 0, 23, 10, 0, 11, 0, 
	16, 16, 28, 12, 18, 0, 15, 13, 
	0, 27, 0, 28, 0, 27, 0, 17, 
	0, 12, 12, 28, 17, 0, 19, 0, 
	16, 16, 22, 28, 12, 20, 0, 21, 
	0, 16, 16, 28, 12, 0, 21, 0, 
	11, 0, 9, 0, 9, 0, 7, 0, 
	14, 0, 0, 0
};

static const int is_generalized_time_start = 1;
static const int is_generalized_time_first_final = 27;
static const int is_generalized_time_error = 0;

static const int is_generalized_time_en_main = 1;


#line 30 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.rl"

bool is_generalized_time(const char *const in, const size_t len)
{
    const char *p = in;
    const char *const pe = in + len;
    int cs;

    
#line 84 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.c"
	{
	cs = is_generalized_time_start;
	}

#line 89 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _is_generalized_time_trans_keys + _is_generalized_time_key_offsets[cs];
	_trans = _is_generalized_time_index_offsets[cs];

	_klen = _is_generalized_time_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _is_generalized_time_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _is_generalized_time_trans_targs[_trans];

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 40 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/generalized_time.rl"


    return cs != is_generalized_time_error;
}
