
#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 16 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.rl"



#line 13 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.c"
static const char _is_integer_key_offsets[] = {
	0, 0, 4, 6, 8
};

static const char _is_integer_trans_keys[] = {
	45, 48, 49, 57, 49, 57, 48, 57, 
	0
};

static const char _is_integer_single_lengths[] = {
	0, 2, 0, 0, 0
};

static const char _is_integer_range_lengths[] = {
	0, 1, 1, 1, 0
};

static const char _is_integer_index_offsets[] = {
	0, 0, 4, 6, 8
};

static const char _is_integer_trans_targs[] = {
	2, 4, 3, 0, 3, 0, 3, 0, 
	0, 0
};

static const int is_integer_start = 1;
static const int is_integer_first_final = 3;
static const int is_integer_error = 0;

static const int is_integer_en_main = 1;


#line 19 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.rl"

bool is_integer(const char *const in, const size_t len)
{
    const char *p = in;
    const char *const pe = in + len;
    int cs;

    
#line 56 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.c"
	{
	cs = is_integer_start;
	}

#line 61 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _is_integer_trans_keys + _is_integer_key_offsets[cs];
	_trans = _is_integer_index_offsets[cs];

	_klen = _is_integer_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _is_integer_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _is_integer_trans_targs[_trans];

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 29 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/integer.rl"


    return cs != is_integer_error;
}
