
#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 15 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"



#line 13 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.c"
static const char _is_numeric_string_key_offsets[] = {
	0, 0, 3
};

static const char _is_numeric_string_trans_keys[] = {
	32, 48, 57, 32, 48, 57, 0
};

static const char _is_numeric_string_single_lengths[] = {
	0, 1, 1
};

static const char _is_numeric_string_range_lengths[] = {
	0, 1, 1
};

static const char _is_numeric_string_index_offsets[] = {
	0, 0, 3
};

static const char _is_numeric_string_trans_targs[] = {
	2, 2, 0, 2, 2, 0, 0
};

static const int is_numeric_string_start = 1;
static const int is_numeric_string_first_final = 2;
static const int is_numeric_string_error = 0;

static const int is_numeric_string_en_main = 1;


#line 18 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"

bool is_numeric_string(const char *const in, const size_t len)
{
    const char *p = in;
    const char *const pe = in + len;
    int cs;

    
#line 54 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.c"
	{
	cs = is_numeric_string_start;
	}

#line 59 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _is_numeric_string_trans_keys + _is_numeric_string_key_offsets[cs];
	_trans = _is_numeric_string_index_offsets[cs];

	_klen = _is_numeric_string_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _is_numeric_string_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	cs = _is_numeric_string_trans_targs[_trans];

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 28 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"


    return cs != is_numeric_string_error;
}
